8180569: Refactor sun/security/krb5/ shell tests to plain java tests

Reviewed-by: mullan
This commit is contained in:
Weijun Wang 2019-02-11 11:01:00 +08:00
parent 128a644ce4
commit 8b83b515b1
9 changed files with 160 additions and 340 deletions

View File

@ -0,0 +1,36 @@
/*
* Copyright (c) 2016, 2019, Oracle and/or its affiliates. All rights reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
*
* This code is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License version 2 only, as
* published by the Free Software Foundation.
*
* This code is distributed in the hope that it will be useful, but WITHOUT
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
* version 2 for more details (a copy is included in the LICENSE file that
* accompanied this code).
*
* You should have received a copy of the GNU General Public License version
* 2 along with this work; if not, write to the Free Software Foundation,
* Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
*
* Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
* or visit www.oracle.com if you need additional information or have any
* questions.
*/
/*
* @test
* @bug 8168518 8194486
* @summary testing jdk.krb5.rcache.useMD5. This action is put in a separate
* test so that ReplayCacheTestProc.java can be launched with special
* test.* system properties easily.
* @library ../../../../java/security/testlibrary/ /test/lib
* @build jdk.test.lib.Platform
* @run main jdk.test.lib.FileInstaller TestHosts TestHosts
* @run main/othervm/timeout=300 -Djdk.krb5.rcache.useMD5=true
* -Djdk.net.hosts.file=TestHosts
* -Dtest.service=host ReplayCacheTestProc
*/

View File

@ -1,34 +0,0 @@
#
# Copyright (c) 2016, 2018, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#
# @test
# @bug 8168518 8194486
# @summary testing jdk.krb5.rcache.useMD5. This action is put in a separate
# test so that ReplayCacheTestProc.java can be launched with special
# test.* system properties easily.
# @library ../../../../java/security/testlibrary/ /test/lib
# @build jdk.test.lib.Platform
# @run main jdk.test.lib.FileInstaller TestHosts TestHosts
# @run main/othervm/timeout=300 -Djdk.krb5.rcache.useMD5=true
# -Djdk.net.hosts.file=TestHosts
# -Dtest.service=host ReplayCacheTestProc

View File

@ -1,5 +1,5 @@
/*
* Copyright (c) 2010, 2011, Oracle and/or its affiliates. All rights reserved.
* Copyright (c) 2010, 2019, Oracle and/or its affiliates. All rights reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
*
* This code is free software; you can redistribute it and/or modify it
@ -21,27 +21,87 @@
* questions.
*/
import java.io.File;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;
import jdk.test.lib.SecurityTools;
import sun.security.krb5.internal.ktab.KeyTab;
import sun.security.krb5.internal.ktab.KeyTabEntry;
/**
* This class is called by the test ktcheck.sh and is not meant to run
* by itself.
/*
* @test
* @bug 6950546
* @summary "ktab -d name etype" to "ktab -d name [-e etype] [kvno | all | old]"
* @requires os.family == "windows"
* @library /test/lib
* @modules java.security.jgss/sun.security.krb5.internal.ktab
* java.security.jgss/sun.security.krb5
*/
public class KtabCheck {
private static final String KEYTAB = "ktab.tmp";
public static void main(String[] args) throws Exception {
Files.deleteIfExists(Path.of(KEYTAB));
ktab("-a me mine");
check(1,16,1,23,1,17);
ktab("-a me mine -n 0");
check(0,16,0,23,0,17);
ktab("-a me mine -n 1 -append");
check(0,16,0,23,0,17,1,16,1,23,1,17);
ktab("-a me mine -append");
check(0,16,0,23,0,17,1,16,1,23,1,17,2,16,2,23,2,17);
ktab("-a me mine");
check(3,16,3,23,3,17);
ktab("-a me mine -n 4 -append");
check(3,16,3,23,3,17,4,16,4,23,4,17);
ktab("-a me mine -n 5 -append");
check(3,16,3,23,3,17,4,16,4,23,4,17,5,16,5,23,5,17);
ktab("-a me mine -n 6 -append");
check(3,16,3,23,3,17,4,16,4,23,4,17,5,16,5,23,5,17,6,16,6,23,6,17);
ktab("-d me 3");
check(4,16,4,23,4,17,5,16,5,23,5,17,6,16,6,23,6,17);
ktab("-d me -e 16 6");
check(4,16,4,23,4,17,5,16,5,23,5,17,6,23,6,17);
ktab("-d me -e 17 6");
check(4,16,4,23,4,17,5,16,5,23,5,17,6,23);
ktab("-d me -e 16 5");
check(4,16,4,23,4,17,5,23,5,17,6,23);
ktab("-d me old");
check(4,16,5,17,6,23);
try {
ktab("-d me old");
throw new Exception("Should fail");
} catch (Exception e) {
// no-op
}
check(4,16,5,17,6,23);
ktab("-d me");
check();
}
static void ktab(String s) throws Exception {
File conf = new File(System.getProperty("test.src"), "onlythree.conf");
SecurityTools.ktab("-J-Djava.security.krb5.conf=" + conf
+ " -k " + KEYTAB + " -f " + s).shouldHaveExitValue(0);
}
/**
* Checks if a keytab contains exactly the keys (kvno and etype)
* @param args keytabname kvno etype...
* @param args kvno etype...
*/
public static void main(String[] args) throws Exception {
static void check(int... args) throws Exception {
System.out.println("Checking " + Arrays.toString(args));
KeyTab ktab = KeyTab.getInstance(args[0]);
KeyTab ktab = KeyTab.getInstance(KEYTAB);
Set<String> expected = new HashSet<>();
for (int i=1; i<args.length; i += 2) {
expected.add(args[i]+":"+args[i+1]);
for (int i = 0; i < args.length; i += 2) {
expected.add(args[i] + ":" + args[i + 1]);
}
for (KeyTabEntry e: ktab.getEntries()) {
// KVNO and etype

View File

@ -1,5 +1,5 @@
/*
* Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
* Copyright (c) 2013, 2019, Oracle and/or its affiliates. All rights reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
*
* This code is free software; you can redistribute it and/or modify it
@ -21,21 +21,25 @@
* questions.
*/
import jdk.test.lib.SecurityTools;
import jdk.test.lib.process.OutputAnalyzer;
import sun.security.krb5.internal.ktab.KeyTab;
import sun.security.krb5.internal.ktab.KeyTabConstants;
import java.io.File;
import java.lang.reflect.Field;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import static jdk.test.lib.SecurityTools.klist;
/*
* @test
* @bug 8014196
* @bug 8014196 7002036 7043737
* @summary ktab creates a file with zero kt_vno
* @requires os.family == "windows"
* @library /test/lib
* @modules java.security.jgss/sun.security.krb5.internal.ktab:+open
* java.security.jgss/sun.security.krb5.internal.tools
*/
public class KtabZero {
@ -45,6 +49,8 @@ public class KtabZero {
// 0. Non-existing keytab
Files.deleteIfExists(Paths.get(NAME));
ktab("-l").shouldNotHaveExitValue(0);
klist("-k " + NAME).shouldNotHaveExitValue(0);
check(true);
// 1. Create with KeyTab
@ -54,9 +60,24 @@ public class KtabZero {
// 2. Create with the tool
Files.deleteIfExists(Paths.get(NAME));
sun.security.krb5.internal.tools.Ktab.main(
("-k " + NAME + " -a me@HERE pass").split(" "));
ktab("-a me@HERE pass").shouldHaveExitValue(0);
ktab("-l").shouldHaveExitValue(0);
// 7002036: ktab return code changes on a error case
ktab("-hello").shouldNotHaveExitValue(0);
ktab("").shouldNotHaveExitValue(0);
check(false);
// 3. Invalid keytab
Files.write(Path.of(NAME), "garbage".getBytes());
ktab("-l").shouldNotHaveExitValue(0);
ktab("-a me@HERE pass").shouldNotHaveExitValue(0);
klist("-k " + NAME).shouldNotHaveExitValue(0);
}
static OutputAnalyzer ktab(String s) throws Exception {
s = ("-k " + NAME + " " + s).trim();
return SecurityTools.ktab(s);
}
// Checks existence as well as kt-vno

View File

@ -1,67 +0,0 @@
#
# Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#
# @test
# @bug 7002036
# @summary ktab return code changes on a error case
# @run shell ktarg.sh
#
if [ "${TESTJAVA}" = "" ] ; then
JAVAC_CMD=`which javac`
TESTJAVA=`dirname $JAVAC_CMD`/..
fi
if [ "${TESTSRC}" = "" ] ; then
TESTSRC="."
fi
OS=`uname -s`
case "$OS" in
CYGWIN* )
FS="/"
;;
Windows_* )
FS="\\"
;;
* )
FS="/"
echo "Unsupported system!"
exit 0;
;;
esac
KEYTAB=ktarg.tmp
rm $KEYTAB 2> /dev/null
KTAB="${TESTJAVA}${FS}bin${FS}ktab -k $KEYTAB"
$KTAB -a me@LOCAL mine || exit 1
$KTAB -hello
if [ $? = 0 ]; then exit 2; fi
$KTAB
if [ $? = 0 ]; then exit 3; fi
exit 0

View File

@ -1,99 +0,0 @@
#
# Copyright (c) 2010, 2012, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#
# @test
# @bug 6950546
# @summary "ktab -d name etype" to "ktab -d name [-e etype] [kvno | all | old]"
# @modules java.security.jgss/sun.security.krb5.internal.ktab
# java.security.jgss/sun.security.krb5
# @compile KtabCheck.java
# @run shell ktcheck.sh
#
if [ "${TESTJAVA}" = "" ] ; then
JAVAC_CMD=`which javac`
TESTJAVA=`dirname $JAVAC_CMD`/..
fi
if [ "${TESTSRC}" = "" ] ; then
TESTSRC="."
fi
OS=`uname -s`
case "$OS" in
CYGWIN* )
FS="/"
;;
Windows_* )
FS="\\"
;;
* )
FS="/"
echo "Unsupported system!"
exit 0;
;;
esac
KEYTAB=ktab.tmp
rm $KEYTAB
EXTRA_OPTIONS="-Djava.security.krb5.conf=${TESTSRC}${FS}onlythree.conf"
KTAB="${TESTJAVA}${FS}bin${FS}ktab -J${EXTRA_OPTIONS} -k $KEYTAB -f"
CHECK="${TESTJAVA}${FS}bin${FS}java -cp ${TESTCLASSES} ${TESTVMOPTS} ${EXTRA_OPTIONS} \
--add-exports java.security.jgss/sun.security.krb5.internal.ktab=ALL-UNNAMED \
--add-exports java.security.jgss/sun.security.krb5=ALL-UNNAMED \
KtabCheck $KEYTAB"
echo ${EXTRA_OPTIONS}
$KTAB -a me mine
$CHECK 1 16 1 23 1 17 || exit 1
$KTAB -a me mine -n 0
$CHECK 0 16 0 23 0 17 || exit 1
$KTAB -a me mine -n 1 -append
$CHECK 0 16 0 23 0 17 1 16 1 23 1 17 || exit 1
$KTAB -a me mine -append
$CHECK 0 16 0 23 0 17 1 16 1 23 1 17 2 16 2 23 2 17 || exit 1
$KTAB -a me mine
$CHECK 3 16 3 23 3 17 || exit 1
$KTAB -a me mine -n 4 -append
$CHECK 3 16 3 23 3 17 4 16 4 23 4 17 || exit 1
$KTAB -a me mine -n 5 -append
$CHECK 3 16 3 23 3 17 4 16 4 23 4 17 5 16 5 23 5 17 || exit 1
$KTAB -a me mine -n 6 -append
$CHECK 3 16 3 23 3 17 4 16 4 23 4 17 5 16 5 23 5 17 6 16 6 23 6 17 || exit 1
$KTAB -d me 3
$CHECK 4 16 4 23 4 17 5 16 5 23 5 17 6 16 6 23 6 17 || exit 1
$KTAB -d me -e 16 6
$CHECK 4 16 4 23 4 17 5 16 5 23 5 17 6 23 6 17 || exit 1
$KTAB -d me -e 17 6
$CHECK 4 16 4 23 4 17 5 16 5 23 5 17 6 23 || exit 1
$KTAB -d me -e 16 5
$CHECK 4 16 4 23 4 17 5 23 5 17 6 23 || exit 1
$KTAB -d me old
$CHECK 4 16 5 17 6 23 || exit 1
$KTAB -d me old
$CHECK 4 16 5 17 6 23 || exit 1
$KTAB -d me
$CHECK || exit 1

View File

@ -1,51 +0,0 @@
#
# Copyright (c) 2011, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#
# @test
# @bug 7043737
# @summary klist does not detect non-existing keytab
# @run shell ktmissing.sh
#
OS=`uname -s`
case "$OS" in
CYGWIN* )
FS="/"
;;
Windows_* )
FS="\\"
;;
* )
FS="/"
echo "Unsupported system!"
exit 0;
;;
esac
${TESTJAVA}${FS}bin${FS}klist -k this_file_does_not_exist && exit 1
echo ABC > this_is_not_a_keytab
${TESTJAVA}${FS}bin${FS}klist -k this_is_not_a_keytab && exit 2
exit 0

View File

@ -1,74 +0,0 @@
#
# Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#
# @test
# @bug 8014196
# @summary ktab creates a file with zero kt_vno
# @run shell ktzero.sh
#
if [ "${TESTJAVA}" = "" ] ; then
JAVAC_CMD=`which javac`
TESTJAVA=`dirname $JAVAC_CMD`/..
fi
if [ "${TESTSRC}" = "" ] ; then
TESTSRC="."
fi
OS=`uname -s`
case "$OS" in
CYGWIN* )
FS="/"
;;
Windows_* )
FS="\\"
;;
* )
FS="/"
echo "Unsupported system!"
exit 0;
;;
esac
KEYTAB=ktzero.tmp
rm $KEYTAB 2> /dev/null
KTAB="${TESTJAVA}${FS}bin${FS}ktab -k $KEYTAB"
# Listing non-existing ktab should fail
$KTAB -l && exit 1
# Can add to non-existing ktab
$KTAB -a me@LOCAL mine || exit 2
# Now can be listed
$KTAB -l || exit 3
echo ABCDEFG > $KEYTAB
# Invalid keytab should fail for all commands
$KTAB -l && exit 4
$KTAB -a me@LOCAL mine && exit 2
exit 0

View File

@ -195,5 +195,33 @@ public class SecurityTools {
public static OutputAnalyzer jarsigner(String... args) throws Exception {
return jarsigner(List.of(args));
}
/**
* Runs ktab.
*
* @param args arguments to ktab in a single string. Only call this if
* there is no white space inside an argument. This string will
* be split with {@code \s+}.
* @return an {@link OutputAnalyzer} object
* @throws Exception if there is an error
*/
public static OutputAnalyzer ktab(String args) throws Exception {
return execute(getProcessBuilder(
"ktab", List.of(args.trim().split("\\s+"))));
}
/**
* Runs klist.
*
* @param args arguments to klist in a single string. Only call this if
* there is no white space inside an argument. This string will
* be split with {@code \s+}.
* @return an {@link OutputAnalyzer} object
* @throws Exception if there is an error
*/
public static OutputAnalyzer klist(String args) throws Exception {
return execute(getProcessBuilder(
"klist", List.of(args.trim().split("\\s+"))));
}
}